clear all

% % Preprocessing:  
% % SAMPLING = 500;     
% % MINDUR_mic = 3;VFAC_mic=5;    MINDUR_sac =6;VFAC_sac = 30; TYPE=3;
% % xl = x(start:end,2:3);                    xr = x(start:end,5:6);
% % xl = smoothdata(xl);                      xr = smoothdata(xr);
% % vl = vecvel(xl,SAMPLING,TYPE);            vr = vecvel(xr,SAMPLING,TYPE);
% % sacl = microsacc(xl,vl,VFAC,MINDUR);      sacr = microsacc(xr,vr,VFAC,MINDUR);
% % sacb = binsacc(sacl,sacr);                sac = saccpar(sacb); 
% % save microsaccades ('msac_vp%') and saccades ('sac_vp%') 

addpath('SAFA_data/');
kl = 20;            % fontsize
vp1 = 1:31;         % subjects
jipp_gesamt = 3;    % background conditions: jipp(1,2,3)
tims = 450;         % time before target onset (350: fixation, 100: gap) in samples
duration = tims+501;% trial duration in samples

%%% 1. relationship saccade latency and occurence interval of last MS before saccade 
for zj = 1:length(vp1)
	vp = vp1(zj);     
    ms1 = load(sprintf('msac_vp%d.txt', vp),'-ascii');
    ms2 = load(sprintf('sac_vp%d.txt', vp),'-ascii');
    
    %%% for every background condition jipp(1,2,3)
    for jipp = 1:jipp_gesamt                
        poll01 = find(ms1(1,:)==jipp-1);
        sac_lat=zeros(1,2);
        for u = 1:length(poll01) 
            %%% find all MS before SA
            sac_avv = ms1(3:length(ms1(:,1)),poll01(u)); 
            ab = find(sac_avv > 0);   
            sac_lat(u,2) = ms2(poll01(u),1);
            poi=find((sac_avv(1:length(ab))-tims-40)<(sac_lat(u,2)));      
            %%% trial with no MS
            if isempty(poi)                
                poi=0; sac_lat(u,1) = 0;
            %%% find last MS before saccade
            else                            
                if sac_avv(length(poi))-tims < (sac_lat(u,2));                               sac_lat(u,1) = sac_avv(length(poi));
                elseif (length(poi)-1~=0 && sac_avv(length(poi-1))-tims < (sac_lat(u,2)));   sac_lat(u,1) = sac_avv(length(poi)-1);
                else                                                                         sac_lat(u,1) = 0;
                end
            end                       
        end

        p0=1;p01=1;p02=1;p03=1;p04=1;p05=1;
        m00=0;m01=0;m02=0;m03=0;m04=0;m05=0;  
        %%% relationship saccade latency and occurence interval of last MS before saccade 
        for zu=1:length(sac_lat)
             if sac_lat(zu,1)==0                                                %MS: none
                m00(p0)=sac_lat(zu,2); p0=p0+1;
            elseif sac_lat(zu,1)-tims>=-400 && sac_lat(zu,1)-tims<-300          %[-800,-600]:FIXATION
                m01(p01)=sac_lat(zu,2); p01=p01+1;
            elseif sac_lat(zu,1)-tims>=-300 && sac_lat(zu,1)-tims<-200          %[-600,-400]:FIXATION
                m02(p02)=sac_lat(zu,2); p02=p02+1;
            elseif sac_lat(zu,1)-tims>=-200 && sac_lat(zu,1)-tims<-100          %[-400,-200]:FIXATION
                m03(p03)=sac_lat(zu,2); p03=p03+1;
            elseif sac_lat(zu,1)-tims>=-100 && sac_lat(zu,1)-tims<0             %[-200,   0]:GAP
                m04(p04)=sac_lat(zu,2); p04=p04+1;
            elseif sac_lat(zu,1)-tims>=0    && sac_lat(zu,1)-tims<100        	%[   0, 200]:TARGET
                m05(p05)=sac_lat(zu,2); p05=p05+1;
            end
        end
        if     jipp == 1
            rat1(vp,:)=[mean(m00) mean(m01) mean(m02) mean(m03) mean(m04) mean(m05)];
        elseif jipp == 2
            rat2(vp,:)=[mean(m00) mean(m01) mean(m02) mean(m03) mean(m04) mean(m05)];
        elseif jipp == 3
            rat3(vp,:)=[mean(m00) mean(m01) mean(m02) mean(m03) mean(m04) mean(m05)];
        end
    end
end


%%% 2. calculate ratio (saccade latency with/without MS) for every interval      
for ip = 1:5
    rat11=[];   
    m=1;
    for oi = 1:length(vp1)
        aundo  = 0;       ao  = 0;     
        aundo2 = 0;       ao2 = 0;
        if (rat1(oi,1)~=0 && rat1(oi,ip+1)~=0);      
            aundo = aundo+rat1(oi,ip+1); ao=ao+1;     
            aundo2 = aundo2+rat1(oi,1);   ao2=ao2+1;
        end
        if (rat2(oi,1)~=0 && rat2(oi,ip+1)~=0);      
            aundo = aundo+rat2(oi,ip+1); ao=ao+1;     
            aundo2 = aundo2+rat2(oi,1);   ao2=ao2+1;
        end
        if (rat3(oi,1)~=0 && rat3(oi,ip+1)~=0);      
            aundo = aundo+rat3(oi,ip+1); ao=ao+1;     
            aundo2 = aundo2+rat3(oi,1);   ao2=ao2+1;
        end          
        if ao>0;    
            rat11(m,1)=aundo2/ao2;  rat11(m,2)=aundo/ao;  m=m+1;     
        end
    end    

    if isempty(rat11);      
        abz(1,ip)=0;    
        abz2(1,ip)=0;
    else
        abz(1,ip)=mean(rat11(:,2)./rat11(:,1));     
        abz2(1,ip)=sqrt(var(rat11(:,2)./rat11(:,1))/31);
    end    
end



figure(3);  
hold on; 
set(gca,'Fontsize',kl); 
set(gcf, 'Color', [1 1 1]);
tz=bar(abz(3:5)); 
set(tz,'facecolor','k'); 
huz=errorbar(1:3,abz(3:5),abz2(3:5),'.k');
ylabel('L_{MS} / L_0'); 
xlabel('Interval'); 
set(gca,'XTick', 1:1:3 ,'YTick', .9:0.1:1.5,'YTickLabel', {'','1.0','', '1.2','','1.4',''})                
axis([0.5 3.5 .9 1.55]);   
axis square; 
box on;
hold off;

                       