clear all

% % Preprocessing
SAMPLING = 500;     
% % MINDUR_mic = 3;VFAC_mic=5;    MINDUR_sac =6;VFAC_sac = 30; TYPE=3;
% % xl = kp(atarg:atrial,2:3);                xr = kp(atarg:atrial,5:6);
% % xl = smoothdata(xl);                      xr = smoothdata(xr);
% % vl = vecvel(xl,SAMPLING,TYPE);            vr = vecvel(xr,SAMPLING,TYPE);
% % sacl = microsacc(xl,vl,VFAC,MINDUR);      sacr = microsacc(xr,vr,VFAC,MINDUR);
% % sacb = binsacc(sacl,sacr);                sac = saccpar(sacb); 
% % save microsaccades ('msac_vp%') and saccades ('sac_vp%') 

addpath('SAFA_data/');
coloredd = 1;       % color or b/w
kl = 20;            % fontsize
lw = 2;             % line width
           
jipp_gesamt = 3;    % number of background conditions 
alpha = 0.05;       % integration parameter 
ting = 200          % integration size
dt = 15;            % integration bin
tims = 350;         % fixation in samples 
duration = tims+501;% trial duration in samples
vp1=1:19;           % subjects

sac_latenc = [380.536  267.376  242.466];    % av. saccade latencies              
r1=zeros(length(vp1),duration);	    % rate uniform background
r2=zeros(length(vp1),duration);	    % rate 1/f background
r3=zeros(length(vp1),duration);	    % rate natural background		

%%% for every person
for zj = 1:length(vp1);					
    vp=vp1(zj);        
    ms1=load(sprintf('msac_vp%d_1.txt', vp),'-ascii');					
	%%% and every background condition 				
    for jipp = 1:jipp_gesamt
        poll01=find(ms1(1,:)==jipp-1);		
        rho_01=zeros(length(poll01),duration);
		%%% count MS-events 				
        for u = 1:length(poll01) 
            sac_avv = ms1(3:length(ms1(:,1)),poll01(u)) ;           
            ab = find(sac_avv > 0);
            for rr=1:length(ab);	
                rho_01(u,sac_avv(ab(rr)))=1;	
            end

        end
        if		jipp == 1;	rho_0 = rho_01; K1 = 1000/length(poll01);
        elseif  jipp == 2;	rho_1 = rho_01; K2 = 1000/length(poll01);
        elseif  jipp == 3;	rho_2 = rho_01; K3 = 1000/length(poll01);	
        end
    end
    %%% sum over all trials
    rho = [sum(rho_0);sum(rho_1);sum(rho_2)];
    %%% calculate ms rate 
    for ie = 1:duration-dt-1					
        rval = zeros(3,1);
        if ie < ting+dt+1;		
            tauend=ie-dt-1;
        else
            tauend=ting;		
        end
        tau=1;
        for taun=tauend:-dt:0
            ie2 = ie;													
            w = alpha^2*(tauend-taun)*exp(-alpha*(tauend-taun));
            rho_tau=sum(rho(1,ie2-(taun):ie2-(taun-dt)));			rval(1,tau)=dt*2*rho_tau*w;
            rho_tau=sum(rho(2,ie2-(taun):ie2-(taun-dt)));			rval(2,tau)=dt*2*rho_tau*w;
            rho_tau=sum(rho(3,ie2-(taun):ie2-(taun-dt)));			rval(3,tau)=dt*2*rho_tau*w;            
            tau=tau+1;
        end
            r1(vp,ie)= sum(rval(1,:)) / (length(rval(1,:))*2) * K1;			%BG 0
            r2(vp,ie)= sum(rval(2,:)) / (length(rval(1,:))*2) * K2;			%BG 1
            r3(vp,ie)= sum(rval(3,:)) / (length(rval(1,:))*2) * K3;			%BG 2
    end		

end                

xx = ((1:duration)-(tims-100+1))/SAMPLING*1000;
%%% Average
mm1=sum(r1)/length(vp1);	%BG 0
nn2=sum(r2)/length(vp1);	%BG 1
oo3=sum(r3)/length(vp1);    %BG 2  
%%% Error
mm12=sqrt(var(r1)/length(vp1));	%BG 0
nn22=sqrt(var(r2)/length(vp1));	%BG 1
oo32=sqrt(var(r3)/length(vp1)); %BG 2  
%%% Smooth
mm1=[xx-ting*1.5;mm1]';     %BG 0
nn2=[xx-ting*1.5;nn2]';     %BG 1
oo3=[xx-ting*1.5;oo3]';     %BG 2
mm12=[xx-ting*1.5;mm12]';   %BG 0
nn22=[xx-ting*1.5;nn22]';   %BG 1
oo32=[xx-ting*1.5;oo32]';   %BG 2
iN=30; 
mm=filter(ones(1,iN)/iN, 1, mm1);   mm(1:iN,:)=mm1(1:iN,:);%BG 0
nn=filter(ones(1,iN)/iN, 1, nn2);   nn(1:iN,:)=nn2(1:iN,:);%BG 1
oo=filter(ones(1,iN)/iN, 1, oo3);   oo(1:iN,:)=oo3(1:iN,:);%BG 2
m2=filter(ones(1,iN)/iN, 1, mm12);   %BG 0
n2=filter(ones(1,iN)/iN, 1, nn22);   %BG 1
o2=filter(ones(1,iN)/iN, 1, oo32);   %BG 2
qw=10;
              
figure(8)
set(gcf, 'Color', [1 1 1],'Position', [100, 50, 900, 300]);     
set(gca,'Fontsize',kl);      
grid on;    
hold on;
%%% microsaccade rates
se=plot(mm(:,1),mm(:,2));set(se,'LineWidth',lw ,'color','g');
se=plot(nn(:,1),nn(:,2));set(se,'LineWidth',lw ,'color','b');
se=plot(oo(:,1),oo(:,2));set(se,'LineWidth',lw ,'color','r');
%%% saccade latencies
se=plot(ones(1,10)+sac_latenc(1),linspace(0,qw,10),'g--');set(se,'LineWidth',lw );
se=plot(ones(1,10)+sac_latenc(2),linspace(0,qw,10),'b--');set(se,'LineWidth',lw );
se=plot(ones(1,10)+sac_latenc(3),linspace(0,qw,10),'r--');set(se,'LineWidth',lw );
%%% fixation-gap-target marker
se=plot(zeros(1,10),linspace(0,qw,10),'k-');set(se,'LineWidth',lw );
set(gca,'YTick', 0:0.5:3 ,'YTickLabel', {'0 ','0.5','1','1.5','2','2.5','3'});  
ylabel('Rate [1/s]','fontsize',kl); 
xlabel('Time [ ms]','fontsize',kl);
axis([-200 450 0 3.0]);   
box on; 
legend('uni','1/f','nat',-1);

  